package cpcns.danganzhengli.mdb_wenjian.service.impl;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import cpcns.common.dao.ICommonDao;
import cpcns.common.service.ICommonService;
import cpcns.common.service.impl.commonServiceImpl;
import cpcns.danganzhengli.mdb_wenjian.dao.MDBWenJianDao;
import cpcns.danganzhengli.mdb_wenjian.dao.MDBWenJianFuJianDao;
import cpcns.danganzhengli.mdb_wenjian.service.MDBWenJianService;
import cpcns.mdbModel.MDBWenJian;
import cpcns.utils.StringUtil;
import java.io.File;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import org.apache.commons.lang3.StringUtils;

public class MDBWenJianServiceImpl extends commonServiceImpl<MDBWenJian> implements MDBWenJianService {
  private MDBWenJianDao mdbWenJianDao;
  
  private MDBWenJianFuJianDao mdbWenJianFuJianDao;
  
  private ICommonService commonService;
  
  public MDBWenJianDao getmdbWenJianDao() {
    return this.mdbWenJianDao;
  }
  
  public void setmdbWenJianDao(MDBWenJianDao mdbWenJianDao) {
    setCommonDao((ICommonDao)mdbWenJianDao);
    this.mdbWenJianDao = mdbWenJianDao;
  }
  
  public MDBWenJianFuJianDao getMdbWenJianFuJianDao() {
    return this.mdbWenJianFuJianDao;
  }
  
  public void setMdbWenJianFuJianDao(MDBWenJianFuJianDao mdbWenJianFuJianDao) {
    this.mdbWenJianFuJianDao = mdbWenJianFuJianDao;
  }
  
  public ICommonService getCommonService() {
    return this.commonService;
  }
  
  public void setCommonService(ICommonService commonService) {
    this.commonService = commonService;
  }
  
  public int parsingMdbNew(String filePath, String mdbPath) {
    try {
      int msg = 0;
      String delwenjian = "delete from MDB_WenJian ";
      String delwenjianfujian = "delete from MDB_WenJianFuJian ";
      this.mdbWenJianDao.deletSQL(delwenjian);
      this.mdbWenJianFuJianDao.deletSQL(delwenjianfujian);
      String wjsql_ = "select max(HANGBIAOSHI) HANGBIAOSHI from MDB_WENJIAN";
      int wjhbs = this.mdbWenJianDao.getMaxHangBiaoShi(wjsql_);
      String fjsql_ = "select max(HANGBIAOSHI) HANGBIAOSHI from MDB_WENJIANFUJIAN";
      int jfhbs = this.mdbWenJianFuJianDao.getMaxHangBiaoShi(fjsql_);
      Connection c = null;
      Statement s = null;
      Statement count = null;
      Class.forName("com.hxtt.sql.access.AccessDriver");
      c = DriverManager.getConnection("jdbc:Access:///" + mdbPath);
      count = c.createStatement();
      ResultSet rs = count.executeQuery("SELECT count(recid) geshu FROM archive_description_jh ");
      while (rs.next())
        msg = Integer.parseInt(rs.getString("geshu")); 
      s = c.createStatement();
      ResultSet r = s.executeQuery("SELECT recid,archive_no,maintitle,created_date,doc_no,fonds_no,filing_year,retention,piece_no,quantity,responsibleby,sbt_word FROM archive_description_jh order by piece_no asc");
      while (r.next()) {
        wjhbs += 4;
        byte[] dh = (byte[])null;
        String danghao = "";
        dh = r.getBytes(2);
        String DangHao = "";
        if (dh != null) {
          DangHao = formatData(new String(dh, "gbk"));
          danghao = formatDangHao(new String(dh, "gbk"));
        } 
        byte[] bt = (byte[])null;
        String biaoti = "";
        bt = r.getBytes(3);
        if (bt != null) {
          biaoti = formatData(new String(bt, "gbk"));
          biaoti = biaoti.replaceAll("'", "");
        } 
        byte[] rq = (byte[])null;
        String beiZhu = "";
        rq = r.getBytes(4);
        String rq_ = "";
        String chengwenriqi = "";
        if (rq != null) {
          rq_ = new String(rq, "gbk");
          System.out.println("源日期======================" + rq_);
          if ("201307011".equals(rq_))
            System.out.println("日期=" + chengwenriqi); 
          chengwenriqi = rq_;
          if (!isDate(rq_)) {
            beiZhu = "日期有问题：" + rq_;
            chengwenriqi = "";
          } 
        } 
        System.out.println("日期=" + chengwenriqi);
        byte[] wh = (byte[])null;
        String wenhao = "";
        wh = r.getBytes(5);
        if (wh != null)
          wenhao = formatData(new String(wh, "gbk")); 
        byte[] qzh = (byte[])null;
        String quanzonghao = "";
        qzh = r.getBytes(6);
        if (qzh != null)
          quanzonghao = formatData(new String(qzh, "gbk")); 
        String lijuandanweimingcheng = "";
        if (quanzonghao != "") {
          String qzsql_ = "select MINGCHENG from G_QUANZONGWEIHU where QUANZONGHAO = '" + quanzonghao + "'";
          List<E> mingChengList = this.commonService.getListSQL(qzsql_);
          lijuandanweimingcheng = mingChengList.get(0).toString();
        } 
        byte[] nd = (byte[])null;
        String niandu = "";
        Integer guidangniandu = Integer.valueOf(0);
        nd = r.getBytes(7);
        if (nd != null) {
          niandu = formatData(new String(nd, "gbk"));
          guidangniandu = Integer.valueOf(Integer.parseInt(niandu));
        } 
        byte[] bgqx = (byte[])null;
        String baoguanqixian = "";
        bgqx = r.getBytes(8);
        if (bgqx != null)
          baoguanqixian = formatBGQX(new String(bgqx, "gbk")); 
        byte[] xh = (byte[])null;
        String xuhao = "";
        Integer xuHao = Integer.valueOf(0);
        xh = r.getBytes(9);
        if (xh != null) {
          xuhao = formatData(new String(xh, "gbk"));
          xuHao = Integer.valueOf(Integer.parseInt(xuhao));
        } 
        byte[] ys = (byte[])null;
        String yeshu = "0";
        Integer yeShu = Integer.valueOf(0);
        ys = r.getBytes(10);
        if (ys != null) {
          yeshu = formatData(new String(ys, "gbk"));
          yeShu = Integer.valueOf(Integer.parseInt(yeshu));
        } 
        byte[] zrz = (byte[])null;
        String zerenzhe = "";
        zrz = r.getBytes(11);
        if (zrz != null)
          zerenzhe = formatData(new String(zrz, "gbk")); 
        byte[] gjz = (byte[])null;
        String guanjianci = "";
        gjz = r.getBytes(12);
        if (gjz != null)
          guanjianci = formatData(new String(gjz, "gbk")); 
        byte[] recid = (byte[])null;
        String beiyongzifu = "";
        recid = r.getBytes(1);
        if (recid != null)
          beiyongzifu = formatData(new String(recid, "gbk")); 
        String lishishujusql_ = "select  HANGBIAOSHI from D_WENJIAN where DANGHAO = '" + DangHao + "' and BIAOTI = '" + biaoti + "' and BAOGUANQIXIAN= '" + baoguanqixian + "'";
        int lishishujuhbs = this.mdbWenJianDao.getMaxHangBiaoShi(lishishujusql_);
        System.out.println("是否文件重复=" + lishishujusql_.toString());
        int zhuangTai = 0;
        if (lishishujuhbs > 4)
          zhuangTai = 1; 
        int youyuanwen = 0;
        if (StringUtils.isNotBlank(beiyongzifu)) {
          String fjsql = "SELECT file_id ,page_no,file_type,file_loc,rec_id,file_name FROM is_files where tble_name='archive_description_jh' and rec_id = '" + beiyongzifu + "' order by page_no";
          ResultSet fj = c.createStatement().executeQuery(fjsql);
          String fuJianLuJing = StringUtil.dealBasePath(String.valueOf(quanzonghao) + File.separator + guidangniandu + File.separator + "XWS" + File.separator + bgqx + File.separator + danghao + File.separator);
          int fujianxuhao = 0;
          while (fj.next()) {
            jfhbs += 4;
            fujianxuhao++;
            byte[] fjgs = (byte[])null;
            String fujiangeshi = "";
            fjgs = fj.getBytes(3);
            if (fjgs != null)
              fujiangeshi = formatData(new String(fjgs, "gbk")); 
            byte[] fjmc = (byte[])null;
            String fujianmingcheng = "";
            fjmc = fj.getBytes(1);
            if (fjmc != null)
              fujianmingcheng = formatData(new String(fjmc, "gbk")); 
            byte[] lj = (byte[])null;
            String fujianlujing = "";
            lj = fj.getBytes(4);
            if (lj != null)
              fujianlujing = formatData(new String(lj, "gbk")); 
            byte[] fjys = (byte[])null;
            String fujianyeshu = "";
            Integer fjyeshu = Integer.valueOf(0);
            fjys = fj.getBytes(2);
            if (ys != null) {
              fujianyeshu = formatData(new String(fjys));
              fjyeshu = Integer.valueOf(Integer.parseInt(fujianyeshu));
            } 
            byte[] ywjm = (byte[])null;
            String yuanfujianmingcheng = "";
            ywjm = fj.getBytes(6);
            if (ywjm != null) {
              yuanfujianmingcheng = formatData(new String(ywjm, "gbk"));
              if (yuanfujianmingcheng.lastIndexOf("pdf") < 1 && yuanfujianmingcheng.lastIndexOf("PDF") < 1)
                yuanfujianmingcheng = String.valueOf(yuanfujianmingcheng.substring(0, yuanfujianmingcheng.indexOf(".") + 1)) + fujiangeshi; 
            } 
            if (StringUtils.isNotBlank(fujianlujing) && (fujiangeshi.equals("tif") || fujiangeshi.equals("pdf") || fujiangeshi.equals("PDF"))) {
              String jisuanjiwenjianming = String.valueOf(danghao) + "_" + fujianxuhao + ".pdf";
              if (!fujiangeshi.equals("tif"))
                jisuanjiwenjianming = String.valueOf(danghao) + "_" + fujianxuhao + "." + fujiangeshi; 
              int fujianleixing = 0;
              if (fujianxuhao == 1)
                fujianleixing = 1; 
              String yuanWenJianLuJing = StringUtil.dealBasePath(String.valueOf(filePath) + fujianlujing + fujianmingcheng + "." + fujiangeshi);
              String fuJianCunFangLuJing = StringUtil.dealBasePath(String.valueOf(fuJianLuJing) + jisuanjiwenjianming);
              String cunfanglujing = StringUtil.dealBasePath(String.valueOf(quanzonghao) + File.separator + guidangniandu + File.separator + "XWS" + File.separator + bgqx + File.separator + danghao + File.separator);
              StringBuffer addfj = (new StringBuffer(" INSERT INTO MDB_WENJIANFUJIAN (HANGBIAOSHI,GUANLIANBIAOSHI,BIAOTI,BEIYONGZIFU,CHENGWENRIQI,CIXU,FUJIANLEIXING,"))
                .append("JISUANJIWENJIANMING,YUANWENJIANMING,WENJIANGESHI,SAOMIAOSECAIMOSHI,TUXIANGYASUOFANGAN,YESHU,FUJIANLAIYUAN,JINJICHENGDU,cunfanglujing,")
                .append("BEIYONGZI,CHANGQIBAOCUNBIAOSHI,SUOYINZHUANGTAI)VALUES (").append(jfhbs).append(",").append(wjhbs).append(",'").append(biaoti)
                .append("','").append(yuanWenJianLuJing);
              if (StringUtils.isNotBlank(chengwenriqi)) {
                addfj.append("',to_date('").append(chengwenriqi).append("','YYYY-MM-DD'),");
              } else {
                addfj.append("','',");
              } 
              addfj.append(fujianxuhao).append(",").append(fujianleixing).append(",'").append(jisuanjiwenjianming).append("','").append(yuanfujianmingcheng).append("','").append(fujiangeshi).append("',0,0,").append(yeshu).append(",0,0,'").append(filePath)
                .append("',1,1,0").append(")");
              System.out.println("文件附件=" + addfj.toString());
            } 
          } 
          System.out.println("附件总个数=" + fujianxuhao);
        } 
        StringBuffer addwj = (new StringBuffer(" INSERT INTO MDB_WENJIAN (HANGBIAOSHI,DANGHAO,XUHAO,WENHAO,ZERENZHE,BIAOTI,"))
          .append("YESHU,DENGJISHIJIAN,CHENGWENRIQI,GUIDANGNIANDU,BAOGUANQIXIAN,QUANZONGHAO,")
          .append("FENSHU,GUIDANGLEIXING,SHUJULAIYUAN,SIXINGJIANCHABIAOSHI,YOUYUANWEN,KAIFANGZHUANGTAI,JIEYUEZHUANGTAI,")
          .append("MENLEI,ZHUANGTAI,LIJUANDANWEIMINGCHENG,GUANJIANCI,BEIZHU)VALUES (").append(wjhbs).append(",'").append(DangHao).append("',")
          .append(xuhao).append(",'").append(wenhao).append("','").append(zerenzhe).append("','").append(biaoti).append("',").append(yeshu);
        if (StringUtils.isNotBlank(chengwenriqi)) {
          addwj.append(",to_date('").append(chengwenriqi).append("','YYYY-MM-DD'),")
            .append("to_date('").append(chengwenriqi).append("','YYYY-MM-DD'),");
        } else {
          addwj.append(",'','',");
        } 
        addwj.append(guidangniandu).append(",'").append(baoguanqixian).append("','").append(quanzonghao).append("',1,2,3,'0|0|0|0',").append(youyuanwen).append(",0,0,'XWS',").append(zhuangTai).append(",")
          .append("'").append(lijuandanweimingcheng).append("','").append(guanjianci).append("','").append(beiZhu).append("')");
        System.out.println("文件=" + addwj.toString());
      } 
    } catch (Exception exception) {}
    return 0;
  }
  
  private static String getDanWeiMingCheng(Connection con, String sql) {
    String mingcheng = "";
    try {
      Statement hstat = con.createStatement();
      ResultSet hres = hstat.executeQuery(sql);
      while (hres.next()) {
        String hbs = hres.getString("MINGCHENG");
        if (StringUtils.isNoneBlank(new CharSequence[] { hbs }))
          mingcheng = hbs; 
      } 
      hstat.close();
      hres.close();
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return mingcheng;
  }
  
  private static String formatData(String str) {
    String result = str;
    if (StringUtils.isBlank(str))
      result = ""; 
    return result;
  }
  
  private static String formatBGQX(String gbqx) {
    String qx = "";
    if (StringUtils.isNoneBlank(new CharSequence[] { gbqx })) {
      if (gbqx.contains("永久")) {
        qx = "Y";
      } else if (gbqx.contains("30年")) {
        qx = "D30";
      } else if (gbqx.contains("10年")) {
        qx = "D10";
      } else if (gbqx.contains("长久")) {
        qx = "CY";
      } else if (gbqx.contains("定期")) {
        qx = "DQ";
      } else if (gbqx.contains("长期")) {
        qx = "CQ";
      } else {
        qx = "";
      } 
    } else {
      qx = "";
    } 
    return qx;
  }
  
  public String formatDangHao(String dangHao) {
    String danghao = dangHao.replaceAll("永久", "Y").replaceAll("30年", "D30")
      .replaceAll("定期", "DQ").replaceAll("长久", "CY").replaceAll("10年", "D10").replaceAll("长期", "CQ");
    return danghao;
  }
  
  public String DangHaoFormat(String dangHao) {
    String danghao = dangHao.replaceAll("Y", "永久").replaceAll("D30", "30年")
      .replaceAll("DQ", "定期").replaceAll("CY", "长久").replaceAll("D10", "10年").replaceAll("CQ", "长期");
    return danghao;
  }
  
  private static String formatriqi(String riqi) {
    if (riqi.length() == 4) {
      riqi = String.valueOf(riqi) + "0101";
      String nian = riqi.substring(0, 4);
      String yue = riqi.substring(4, 6);
      String ri = riqi.substring(6, riqi.length());
      riqi = String.valueOf(nian) + "-" + yue + "-" + ri;
    } 
    if (riqi.length() == 6)
      if (riqi.indexOf("-") > 0) {
        riqi = String.valueOf(riqi) + "-1";
      } else {
        riqi = String.valueOf(riqi) + "01";
        String nian = riqi.substring(0, 4);
        String yue = riqi.substring(4, 6);
        int y = Integer.parseInt(yue);
        if (y == 0 || y > 12)
          yue = "01"; 
        String ri = riqi.substring(6, riqi.length());
        riqi = String.valueOf(nian) + "-" + yue + "-" + ri;
      }  
    if (riqi.length() == 7)
      if (riqi.indexOf("-") > 0) {
        riqi = String.valueOf(riqi) + "-1";
      } else {
        riqi = "";
      }  
    if (riqi.length() == 8 && 
      riqi.indexOf("-") <= 0) {
      String nian = riqi.substring(0, 4);
      String yue = riqi.substring(4, 6);
      int y = Integer.parseInt(yue);
      if (y == 0 || y > 12)
        yue = "01"; 
      String ri = riqi.substring(6, riqi.length());
      int r = Integer.parseInt(ri);
      if (r == 0 || r > 12)
        ri = "01"; 
      riqi = String.valueOf(nian) + "-" + yue + "-" + ri;
    } 
    if (riqi.length() > 8)
      riqi = ""; 
    return riqi;
  }
  
  public static boolean isDate(String riqi) {
    Pattern pattern = 
      Pattern.compile("^((\\d{2}(([02468][048])|([13579][26]))[\\-\\/\\s]?((((0?[13578])|(1[02]))[\\-\\/\\s]?((0?[1-9])|([1-2][0-9])|(3[01])))|(((0?[469])|(11))[\\-\\/\\s]?((0?[1-9])|([1-2][0-9])|(30)))|(0?2[\\-\\/\\s]?((0?[1-9])|([1-2][0-9])))))|(\\d{2}(([02468][1235679])|([13579][01345789]))[\\-\\/\\s]?((((0?[13578])|(1[02]))[\\-\\/\\s]?((0?[1-9])|([1-2][0-9])|(3[01])))|(((0?[469])|(11))[\\-\\/\\s]?((0?[1-9])|([1-2][0-9])|(30)))|(0?2[\\-\\/\\s]?((0?[1-9])|(1[0-9])|(2[0-8]))))))(\\s(((0?[0-9])|([1-2][0-3]))\\:([0-5]?[0-9])((\\s)|(\\:([0-5]?[0-9])))))?$");
    Matcher m = pattern.matcher(riqi);
    if (m.matches() && riqi.length() == 8)
      return true; 
    System.out.println("此日期格式有误");
    return false;
  }
}
